com.fasterxml.jackson.databind.deser.std

## Class ObjectArrayDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase<Object>
      - - com.fasterxml.jackson.databind.deser.std.ObjectArrayDeserializer

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, ValueInstantiator.Gettable, Serializable

    public class ObjectArrayDeserializer
    extends ContainerDeserializerBase<Object>
    implements ContextualDeserializer

Serializer that can serialize non-primitive arrays.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected Class<?>` `_elementClass` Type of contained elements: needed for constructing actual result array
`protected JsonDeserializer<Object>` `_elementDeserializer` Element deserializer
`protected TypeDeserializer` `_elementTypeDeserializer` If element instances have polymorphic type information, this is the type deserializer that can handle it
`protected Object[]` `_emptyValue`
`protected boolean` `_untyped` Flag that indicates whether the component type is Object or not.

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

`_containerType, _nullProvider, _skipNullValues, _unwrapSingle`

### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_valueClass, _valueType, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

### Constructor Summary

Constructors
`` `ObjectArrayDeserializer(JavaType arrayType0, JsonDeserializer<Object> elemDeser, TypeDeserializer elemTypeDeser)`
`protected` `ObjectArrayDeserializer(ObjectArrayDeserializer base, JsonDeserializer<Object> elemDeser, TypeDeserializer elemTypeDeser, NullValueProvider nuller, Boolean unwrapSingle)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected Object[]` `_deserialize(JsonParser p, DeserializationContext ctxt, ObjectBuffer buffer, int ix, Object[] chunk)`
`protected Object` `_deserializeNoNullChecks(JsonParser p, DeserializationContext ctxt)` Deserialize the content of the map.
`protected Object[]` `_deserializeWithObjectId(JsonParser p, DeserializationContext ctxt)`
`protected Object[]` `_wrapSingleWithObjectId(JsonParser p, DeserializationContext ctxt)`
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`Object` `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `deserialize(JsonParser p, DeserializationContext ctxt, Object intoValue0)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
`protected Byte[]` `deserializeFromBase64(JsonParser p, DeserializationContext ctxt)`
`Object` `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
`JsonDeserializer<Object>` `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
`AccessPattern` `getEmptyAccessPattern()` This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.
`Object` `getEmptyValue(DeserializationContext ctxt)` Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings).
`protected Object` `handleNonArray(JsonParser p, DeserializationContext ctxt)`
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`LogicalType` `logicalType()` Method for accessing logical type of values this deserializer produces.
`ObjectArrayDeserializer` `withDeserializer(TypeDeserializer elemTypeDeser, JsonDeserializer<?> elemDeser)` Overridable fluent-factory method used to create contextual instances
`ObjectArrayDeserializer` `withResolved(TypeDeserializer elemTypeDeser, JsonDeserializer<?> elemDeser, NullValueProvider nuller, Boolean unwrapSingle)`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

`findBackReference, getContentType, getValueType, supportsUpdate, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

`_byteOverflow, _checkBooleanToStringCoercion, _checkCoercionFail, _checkDoubleSpecialValue, _checkFloatSpecialValue, _checkFloatToIntCoercion, _checkFloatToStringCoercion, _checkFromStringCoercion, _checkFromStringCoercion, _checkIntToFloatCoercion, _checkIntToStringCoercion, _checkTextualNull, _checkToStringCoercion, _coerceBooleanFromInt, _coercedTypeDesc, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeFromEmptyString, _deserializeFromString, _deserializeWrappedValue, _failDoubleToIntCoercion, _findCoercionFromBlankString, _findCoercionFromEmptyArray, _findCoercionFromEmptyString, _findNullProvider, _hasTextualNull, _intOverflow, _isBlank, _isEmptyOrTextualNull, _isFalse, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _isTrue, _neitherNull, _nonNullNumber, _parseBoolean, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDouble, _parseDouble, _parseDoublePrimitive, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseInteger, _parseInteger, _parseInteger, _parseIntPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLong, _parseLong, _parseLong, _parseLongPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _parseString, _reportFailedNullCoerce, _shortOverflow, _streamReadConstraints, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueInstantiator, getValueType, handledType, handleMissingEndArrayForSingle, handleNestedArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer`

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserializeWithType, getAbsentValue, getDelegatee, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.fasterxml.jackson.databind.deser.ValueInstantiator.Gettable

`getValueInstantiator`

### Field Detail

#### _untyped

    protected final boolean _untyped

Flag that indicates whether the component type is Object or not. Used for minor optimization when constructing result.

#### _elementClass

    protected final Class<?> _elementClass

Type of contained elements: needed for constructing actual result array

#### _elementDeserializer

    protected JsonDeserializer<Object> _elementDeserializer

Element deserializer

#### _elementTypeDeserializer

    protected final TypeDeserializer _elementTypeDeserializer

If element instances have polymorphic type information, this is the type deserializer that can handle it

#### _emptyValue

    protected final Object[] _emptyValue

Since:
  2.12

### Constructor Detail

#### ObjectArrayDeserializer

    public ObjectArrayDeserializer(JavaType arrayType0,
                                   JsonDeserializer<Object> elemDeser,
                                   TypeDeserializer elemTypeDeser)

#### ObjectArrayDeserializer

    protected ObjectArrayDeserializer(ObjectArrayDeserializer base,
                                      JsonDeserializer<Object> elemDeser,
                                      TypeDeserializer elemTypeDeser,
                                      NullValueProvider nuller,
                                      Boolean unwrapSingle)

### Method Detail

#### withDeserializer

    public ObjectArrayDeserializer withDeserializer(TypeDeserializer elemTypeDeser,
                                                    JsonDeserializer<?> elemDeser)

Overridable fluent-factory method used to create contextual instances

#### withResolved

    public ObjectArrayDeserializer withResolved(TypeDeserializer elemTypeDeser,
                                                JsonDeserializer<?> elemDeser,
                                                NullValueProvider nuller,
                                                Boolean unwrapSingle)

Since:
  2.7

#### isCachable

    public boolean isCachable()

Description copied from class: `JsonDeserializer`
Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

Overrides:
  `isCachable` in class `JsonDeserializer<Object>`

#### logicalType

    public LogicalType logicalType()

Description copied from class: `JsonDeserializer`
Method for accessing logical type of values this deserializer produces. Typically used for further configuring handling of values, for example, to find which coercions are legal.

Overrides:
  `logicalType` in class `JsonDeserializer<Object>`
Returns:
  Logical type of values this deserializer produces, if known; `null` if not

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException` - If there is problem with contextualization

#### getContentDeserializer

    public JsonDeserializer<Object> getContentDeserializer()

Description copied from class: `ContainerDeserializerBase`
Accesor for deserializer use for deserializing content values.

Specified by:
  `getContentDeserializer` in class `ContainerDeserializerBase<Object>`

#### getEmptyAccessPattern

    public AccessPattern getEmptyAccessPattern()

Description copied from class: `JsonDeserializer`
This method may be called in conjunction with calls to `JsonDeserializer.getEmptyValue(DeserializationContext)`, to check whether it needs to be called just once (static values), or each time empty value is needed.

Overrides:
  `getEmptyAccessPattern` in class `ContainerDeserializerBase<Object>`

#### getEmptyValue

    public Object getEmptyValue(DeserializationContext ctxt)
                         throws JsonMappingException

Description copied from class: `JsonDeserializer`
Method called to determine value to be used for "empty" values (most commonly when deserializing from empty JSON Strings). Usually this is same as `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` (which in turn is usually simply Java null), but it can be overridden for specific types. Or, if type should never be converted from empty String, method can also throw an exception.

This method may be called once, or multiple times, depending on what `JsonDeserializer.getEmptyAccessPattern()` returns.

Default implementation simply calls `JsonDeserializer.getNullValue(com.fasterxml.jackson.databind.DeserializationContext)` and returns value.

Overrides:
  `getEmptyValue` in class `ContainerDeserializerBase<Object>`
Throws:
  `JsonMappingException`

#### deserialize

    public Object deserialize(JsonParser p,
                              DeserializationContext ctxt)
                       throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.currentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Handling null values (JsonToken.VALUE_NULL)
: Note that this method is never called for the JSON `null` literal to avoid every deserializer from having to handle null values. Instead, the `JsonDeserializer.getNullValue(DeserializationContext)` method is called to produce a null value. To influence null handling, custom deserializers should override `JsonDeserializer.getNullValue(DeserializationContext)` and usually also `JsonDeserializer.getNullAccessPattern()`.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `p` - Parser used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### _deserialize

    protected Object[] _deserialize(JsonParser p,
                                    DeserializationContext ctxt,
                                    ObjectBuffer buffer,
                                    int ix,
                                    Object[] chunk)
                             throws JsonMappingException

Throws:
  `JsonMappingException`

#### _deserializeWithObjectId

    protected Object[] _deserializeWithObjectId(JsonParser p,
                                                DeserializationContext ctxt)
                                         throws JsonMappingException

Throws:
  `JsonMappingException`

#### deserializeWithType

    public Object deserializeWithType(JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `StdDeserializer`
Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.

Overrides:
  `deserializeWithType` in class `StdDeserializer<Object>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### deserialize

    public Object deserialize(JsonParser p,
                              DeserializationContext ctxt,
                              Object intoValue0)
                       throws IOException

Description copied from class: `JsonDeserializer`
Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

Overrides:
  `deserialize` in class `JsonDeserializer<Object>`
Throws:
  `IOException`

#### deserializeFromBase64

    protected Byte[] deserializeFromBase64(JsonParser p,
                                           DeserializationContext ctxt)
                                    throws IOException

Throws:
  `IOException`

#### handleNonArray

    protected Object handleNonArray(JsonParser p,
                                    DeserializationContext ctxt)
                             throws IOException

Throws:
  `IOException`

#### _wrapSingleWithObjectId

    protected Object[] _wrapSingleWithObjectId(JsonParser p,
                                               DeserializationContext ctxt)
                                        throws IOException

Throws:
  `IOException`

#### _deserializeNoNullChecks

    protected Object _deserializeNoNullChecks(JsonParser p,
                                              DeserializationContext ctxt)
                                       throws IOException

Deserialize the content of the map. If _elementTypeDeserializer is null, use _elementDeserializer.deserialize; if non-null, use _elementDeserializer.deserializeWithType to deserialize value. This method only performs deserialization and does not consider _skipNullValues, _nullProvider, etc.

Throws:
  `IOException`
Since:
  2.19.2